/*
 **************************************************************************
 *		SWI-Prolog ActiveX Extensions.
 *
 *	This software is provided in source and binary form free of charge to 
 *  users of SWI-Prolog.  No warranty of any kind is expressed or implied;
 *  in particular, this is entirely unsupported software.
 *
 *  Documentation for this product is available from the SWI-Prolog 
 *  web site (http://www.swi.psy.uva.nl/projects/SWI-Prolog/).
 *
 *	Version 1.0.1.
 *
 *	October 1, 1999
 *
 **************************************************************************
 */

// PrologQuery.h : Declaration of the CPrologQuery

#ifndef __PROLOGQUERY_H_
#define __PROLOGQUERY_H_

#include "zstr.h"
#include "resource.h"       // main symbols
#include "SWI-Prolog.h"

/////////////////////////////////////////////////////////////////////////////
// CPrologQuery
class ATL_NO_VTABLE CPrologQuery : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPrologQuery, &CLSID_PrologQuery>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CPrologQuery>,
	public IDispatchImpl<IPrologQuery, &IID_IPrologQuery, &LIBID_PROQUERYLib>
{
public:
	CPrologQuery();
	~CPrologQuery();

DECLARE_REGISTRY_RESOURCEID(IDR_PROLOGQUERY)

DECLARE_PROTECT_FINAL_CONSTRUCT()
 
BEGIN_COM_MAP(CPrologQuery)
	COM_INTERFACE_ENTRY(IPrologQuery)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CPrologQuery)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


// IPrologQuery
public:
	STDMETHOD(ModulePath)(/*[out,retval]*/ BSTR * pbstrPath);
	STDMETHOD(SetPredicate)(/*[in]*/ BSTR bstrName, 
							/*[in]*/ long iArity, 
							/*[in]*/ BSTR bstrModule);
	STDMETHOD(OpenQuery)(	/*[in]*/ long iFlags, 
							/*[in]*/ SAFEARRAY * * prgArgs);
	STDMETHOD(NextSolution)(/*[out]*/ SAFEARRAY * * prgArgs,
							/*[out,retval]*/ VARIANT_BOOL * pbSucceed);
	STDMETHOD(CutQuery)();
	STDMETHOD(CloseQuery)();

	HRESULT FinalConstruct ();

protected:
	SAFEARRAY * _psfaArgs;
	int _iArity;
	predicate_t _pred;
	qid_t _qid;
	term_t _tArgs;
	fid_t _fframe;
	ZSTR _zsModulePath;

	static int _cInstances;

protected:

	HRESULT Error ( UINT nID );
	HRESULT Error ( TSZC tszcDesc, const IID & iid, HRESULT hRes );
	HRESULT HrConvertTermsToSafeArray ( term_t tTerms, int cTerms, SAFEARRAY * * ppsfa );
	HRESULT HrConvertSafeArrayToTerms ( VARTYPE vt, SAFEARRAY * psfa, term_t tArgs );
	HRESULT HrConvertSafeArrayElementToTerm ( VARTYPE vt, void * pv, term_t tElem );
	HRESULT HrSafeArrayBounds ( SAFEARRAY * psfa, int iDim, LONG & iLbound, LONG & iUbound );

	void ResetAll ();
	void ResetQuery();
	void InitProlog ();

	class CHDIR 
	{
	  public:
		CHDIR ( TSZC tszcPath );
		~ CHDIR ();
	  protected:
		ZSTR _zsPath;
	};
};

#endif //__PROLOGQUERY_H_
